﻿using EduSpider.IRepository;
using EduSpider.Model.Entity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EduSpider.Repository
{
    /// <summary>
    /// 课程评价配置详情仓储接口实现
    /// </summary>
    public class CourseCommentDetailsRepository : Base.BaseRepository<RB_Course_CommentDetails>, ICourseCommentDetailsRepository
    {
        /// <summary>
        /// 新增修改课程评价
        /// </summary>
        /// <param name="list"></param>
        /// <returns></returns>
        public bool SetCourseCommentDetailsRepository(List<RB_Course_CommentDetails> list)
        {
            bool flag = true;
            if (list != null && list.Count > 0)
            {
                foreach (var item in list)
                {
                    if (flag)
                    {
                        if (item.DetailId > 0)
                        {
                            Dictionary<string, object> fileds = new()
                            {
                                {nameof(RB_Course_CommentDetails.StartNum),item.StartNum },
                                {nameof(RB_Course_CommentDetails.EndNum),item.EndNum },
                                {nameof(RB_Course_CommentDetails.Info),item.Info },
                            };
                            flag = base.UpdateOne(fileds, new VTX.FW.DB.WhereHelper(nameof(RB_Course_CommentDetails.DetailId), item.DetailId));
                        }
                        else
                        {
                            var newId = base.Insert(item);
                            item.DetailId = newId;
                            flag = newId > 0;
                        }
                    }
                }
            }
            return flag;
        }

        /// <summary>
        /// 获取课程评价配置列表
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Course_CommentDetails> GetCourseCommentDetailsListRepository(RB_Course_Comment query)
        {
            StringBuilder builder = new();
            builder.AppendFormat(@"
SELECT A.*
FROM RB_Course_CommentDetails AS A
WHERE 1=1
");
            if (query != null)
            {
                if (query.Id > 0)
                {
                    builder.AppendFormat(" AND A.{0}={1} ", nameof(RB_Course_CommentDetails.CourseCommentId), query.Id);
                }
            }
            return Get<RB_Course_CommentDetails>(builder.ToString()).ToList();
        }
    }
}
